<template>
  <q-page class="text-center">
    <div class="q-pa-md">
      <h2>Welcome, admin!</h2>
      <br />
      <div class="row justify-center">
        <q-btn
          class="q-ml-sm"
          color="dark"
          icon="add_box"
          label="Create Poll"
          clickable
          exact
          to="/admin/createpoll"
        />
        <q-btn
          class="q-ml-sm"
          color="dark"
          icon="add_box"
          label="Add User"
          clickable
          exact
          to="/admin/adduser"
        />
        <!-- <q-btn
        class="q-ml-sm"
        color="dark"
        icon="upload"
        label="Import Users from CSV"
      >
      <input type="file" :name="uploadFieldName" :disabled="isSaving" @change="filesChange($event.target.name, $event.target.files); "
            accept="image/*" class="input-file">
      </q-btn> -->
        <q-file
          outlined
          v-model="UploadCSV"
          class="q-ml-sm"
          label-color="white"
          bg-color="dark"
          label="Import Users from CSV"
          style="width: 350px"
          accept=".csv"
          @rejected="onRejected"
        >
          <template v-slot:prepend>
            <q-icon color="white" name="upload" />
          </template>
          <template v-if="UploadCSV" v-slot:append>
            <q-icon
              color="white"
              name="cancel"
              @click.stop.prevent="UploadCSV = null"
              class="cursor-pointer"
            />
            <q-btn
              class="q-ml-sm text-right"
              color="dark"
              label="Generate"
              @click="generateUsers"
            />
          </template>
          <template v-slot:file="{ index, file }">
            <div class="ellipsis text-white relative-position">
              {{ file.name }}
            </div>
          </template>
        </q-file>
      </div>
      <!-- TODO: add table with all polls   -->
    </div>
    <div class="q-pa-md">
      <q-btn class="q-ml-sm" color="dark" label="Polls" @click="showPolls" />
      <q-btn class="q-ml-sm" color="dark" label="Users" @click="showUsers" />
    </div>
    <div class="q-pa-md">
      <q-table
        class="table-responsive"
        v-if="togglePolls"
        title="Polls"
        :data="pollsData"
        :columns="pollsColumns"
        row-key="tkn"
      >
        <template v-slot:body-cell-actions="props">
          <q-td :props="props">
            <q-btn
              dense
              round
              flat
              color="grey"
              @click="seeDetails(props)"
              icon="info"
            ></q-btn>
            <q-btn
              dense
              round
              flat
              color="grey"
              @click="editPoll(props)"
              icon="edit"
            ></q-btn>
            <q-btn
              dense
              round
              flat
              color="grey"
              @click="deletePoll(props)"
              icon="delete"
            ></q-btn>
          </q-td>
        </template>
      </q-table>
      <q-table
        class="table-responsive"
        v-if="toggleUsers"
        title="Users"
        :data="userData"
        :columns="userColumns"
        row-key="username"
      >
        <template v-slot:body-cell-actions="props">
          <q-td :props="props">
            <q-btn
              dense
              round
              flat
              color="grey"
              @click="editUser(props)"
              icon="edit"
            ></q-btn>
            <q-btn
              dense
              round
              flat
              color="grey"
              @click="deleteUser(props)"
              icon="delete"
            ></q-btn>
          </q-td>
        </template>
      </q-table>
    </div>
  </q-page>
</template>

<script>
import { ref } from "@vue/composition-api";
// import { ref } from "vue";
import { api } from "boot/axios";
const dateFormat = require("dateformat");

export default {
  name: "PageIndex",

  data() {
    return {
      UploadCSV: null,
      togglePolls: true,
      toggleUsers: false,
      tableToggle: "true",
      pollsColumns: [
        {
          name: "question",
          align: "left",
          label: "Question",
          field: "question",
          sortable: true
        },
        { name: "desc", align: "right", label: "Description", field: "desc" },
        { name: "tkn", label: "Token", field: "tkn" },
        {
          name: "startdate",
          label: "Opens",
          field: record => {
            // console.log(record.open_date);
            const close = Date.parse(record.open_date);
            // return close.toLocaleString();
            return dateFormat(close, "dd/mm/yyyy HH:MM");
          },
          sortable: true
        },
        {
          name: "enddate",
          label: "Closes",
          field: record => {
            // console.log(record.close_date);
            const close = Date.parse(record.close_date);
            // return close.toLocaleString();
            return dateFormat(close, "dd/mm/yyyy HH:MM");
          },
          sortable: true
        },
        { name: "status", label: "Status", field: "poll_status" },
        { name: "quorum", label: "Quorum", field: "quorum" },
        { name: "res", label: "Result", field: "result" },
        { name: "actions", label: "Actions", field: "", align: "center" }
      ],
      pollsData: [],

      userColumns: [
        {
          name: "username",
          label: "username",
          field: "username",
          sortable: true
        },
        {
          name: "is_admin",
          label: "is_admin",
          field: "isAdmin",
          sortable: true
        },
        {
          name: "dep_code",
          label: "dep_code",
          field: "dep_code",
          sortable: true
        },
        {
          name: "hire_date",
          label: "hire_date",
          field: "hire_date",
          sortable: true
        },
        {
          name: "position",
          label: "position",
          field: "position",
          sortable: true
        },
        {
          name: "job_rank",
          label: "job_rank",
          field: "jobRank",
          sortable: true
        },
        {
          name: "has_ever_logged_in",
          label: "has_ever_logged_in",
          field: "hasEverLoggedIn"
        },
        { name: "actions", label: "Actions", field: "", align: "center" }
      ],
      userData: []
    };
  },
  methods: {
    getUsers() {
      api
        .post("/api/admin/getUsers", { token: sessionStorage.token })
        .then(res => {
          this.userData = res.data.users;
        })
        .catch(() => {
          console.log("Error retrieving users");
        });
    },

    getPolls() {
      api
        .post("/api/admin/getPolls", { token: sessionStorage.token })
        .then(res => {
          this.pollsData = res.data.polls;
        })
        .catch(() => {
          console.log("Error retrieving polls");
        });
    },

    showUsers() {
      this.togglePolls = false;
      this.toggleUsers = true;
    },
    showPolls() {
      this.togglePolls = true;
      this.toggleUsers = false;
    },
    seeDetails(props) {
      this.$router.push({ path: "/details/" + props.key });
    },
    editPoll(props) {
      // console.log(props);
      console.log("editPoll");
      var reqData = {
        polltkn: props.key
      };
      api
        .post("/api/poll/canBeModified", reqData)
        .then(res => {
          // console.log("orice");
          // console.log(res.status);
          // console.log(res.data);
          if (res.status == 200) {
            if (res.data.canBeModified == true)
              this.$router.push("/admin/editpoll/" + props.key);
            if (res.data.canBeModified == false)
              this.$q.notify({
                color: "red-5",
                textColor: "white",
                icon: "warning",
                message: `Cannot modify poll`
              });
          }
        })
        .catch(error => {
          this.$q.notify({
            color: "red-5",
            textColor: "white",
            icon: "warning",
            message: error.message
          });
        });
    },
    deletePoll(props) {
      console.log(props);
      const reqData = {
        tkn: props.key,
        token: sessionStorage.token
      };
      api
        .post("/api/poll/canBeModified", reqData)
        .then(res => {
          if (res.status == 200 && res.data.canBeModified == true) {
            api
              .post("/api/poll/deletePoll", reqData)
              .then(res => {
                if (res.status == 200)
                  this.$q.notify({
                    color: "secondary",
                    textColor: "white",
                    icon: "check",
                    message: `Poll deleted: ${reqData.tkn}`
                  });
              })
              .catch(error => {
                this.$q.notify({
                  color: "red-5",
                  textColor: "white",
                  icon: "warning",
                  message: error.message
                });
              });
          } else {
            this.$q.notify({
              color: "red-5",
              textColor: "white",
              icon: "warning",
              message: "Poll cannot be deleted!"
            });
          }
        })
        .catch(error => {
          this.$q.notify({
            color: "red-5",
            textColor: "white",
            icon: "warning",
            message: error.message
          });
        });
    },
    editUser(props) {
      console.log(props);
      this.$router.push("/admin/edituser/" + props.key);
    },
    deleteUser(props) {
      console.log(props);
      const reqData = {
        username: props.key,
        token: sessionStorage.token
      };

      api
        .post("/api/user/deleteUser", reqData)
        .then(res => {
          if (res.status == 200)
            this.$q.notify({
              color: "secondary",
              textColor: "white",
              icon: "check",
              message: `User deleted: ${reqData.username}`
            });
        })
        .catch(error => {
          this.$q.notify({
            color: "red-5",
            textColor: "white",
            icon: "warning",
            message: error.message
          });
        });
    },
    onRejected(rejectedEntry) {
      this.$q.notify({
        color: "red-5",
        textColor: "white",
        icon: "warning",
        message: `File needs to be of CSV format`
      });
    },
    generateUsers() {
      console.log(this.UploadCSV);

      let formData = new FormData();
      formData.append("file", this.UploadCSV);
      formData.append("token", sessionStorage.token);

      api
        .post("/api/admin/uploadCSV", formData, {
          headers: {
            "Content-Type": "multipart/form-data"
          }
        })
        .then(res => {
          console.log("file upload successful. starting generation");
          console.log(res.data);

          const reqData = {
            filename: res.data.filename,
            token: sessionStorage.token
          };

          api
            .post("/api/admin/generateUsers", reqData)
            .then(res => {
              // console.log(res.data);
              if (res.status == 200)
                this.$q.notify({
                  color: "secondary",
                  textColor: "white",
                  icon: "check",
                  message: "Users generated and added to DB"
                });
            })
            .catch(error => {
              this.$q.notify({
                color: "red-5",
                textColor: "white",
                icon: "warning",
                message: "Server error when generating users from uploaded file"
              });
            });
        })
        .catch(function() {
          this.$q.notify({
            color: "red-5",
            textColor: "white",
            icon: "warning",
            message: "Server error when uploading file"
          });
        });
    }
  },
  created() {
    this.getUsers();
    this.getPolls();
  }
  // setup() {
  //   return {
  //     UploadCSV: ref(null)
  //   };
  // }
};
</script>

<style scoped>
.q-btn {
  margin-left: 5px;
}
</style>
